/* RgTwit.C */

#include <falcon.h>
#include "..\Src\H\regina.h"

#define  COMPAT_VER           5
#define  COMPAT_BUILD         98
#define  COMPAT_VERSION       (COMPAT_VER<<16)+COMPAT_BUILD
#define  USED_HOOKS           1

/*----------------------------------------------------------------------------*/
APIRET APIENTRY HookGetSignature(VOID) {

  return(HOOK_SIGNATURE);
}
/*----------------------------------------------------------------------------*/
CHAR * APIENTRY HookGetName(VOID) {

  return("Empty hook for "PrgShort);
}
/*----------------------------------------------------------------------------*/
ULONG APIENTRY HookInitModule(CHAR *ModuleName) {
  ULONG             i;

  if (!CheckVersion(COMPAT_VERSION)) {
    i=0; printf("EmptyHook: initing...\n");
  }
  else {
    i=1; printf("EmptyHook: not loading!\n");
  }
  return(i);
}
/*----------------------------------------------------------------------------*/
VOID APIENTRY HookQueryProcs(PHOOK_ALL_INFO hi) {

  hi->hooks=MallocH(sizeof(hi->hooks[0])*USED_HOOKS);
  hi->hooks->ordinal=100; hi->hooks->usage=HOOK_BEFORE_STORE_MSG;
  hi->NumOfFunc=USED_HOOKS;
  printf("EmptyHook: reporting ordinals...\n");
}
/*----------------------------------------------------------------------------*/
ULONG APIENTRY HookTermModule(VOID) {

  printf("EmptyHook: terminating.\n"); return(NO_ERROR);
}
/*----------------------------------------------------------------------------*/
ULONG HookStoreMsg(VOID *data) {
  PMG               mg;

  mg=((PHOOK_DATA) data)->msg;
  printf("EmptyHook: Storing %s:%s->%s\n", mg->area, mg->from, mg->to);
  return(NO_ERROR);
}
/*----------------------------------------------------------------------------*/
