/*
   Programm     GRRELINK.CMD
   Owner        2:5085/1@FIDOnet.org, Sergey Popov
   Date         21.11.2000
   Comment      This script changes one echos' uplink to another for specified
                group of echos
   Creator      S. Popov (2:5085/1.41 AKA 2:5085/1.104)
   Note         This script requires Regina-Tosser/2 b091
   Execute      Regina Hand REXX grrelink.cmd olduplink newuplink groupnum
*/

  /* Initializing */
  If RxFuncQuery( 'SysLoadFuncs' ) \= 0 Then
    Do
      Call RxFuncAdd 'SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs'
      Call SysLoadFuncs
    End /* If RxFuncQuery */

  Parse Upper Arg ThisArg
  Parse Source . . ThisProg
  ThisPath  = FileSpec('D', thisProg) || FileSpec('P', thisProg)

  Call SysCls
  Call SysCurState 'OFF'

  Mark.WhiteOnBlue  = '1B'x || '[1;37;44m'
  Mark.WhiteOnBlack = '1B'x || '[0m'
  Mark.RedOnBlack   = '1B'x || '[1;31;40m'
  Mark.GreenOnBlack = '1B'x || '[1;32;40m'
  Mark.CyanOnBlack  = '1B'x || '[1;36;40m'
  Mark.ClearRest    = '1B'x || '[K'

  Sentence = Mark.GreenOnBlack || RgSysVer('B') || Mark.WhiteOnBlack
  rc = SayIn(0, 0, Sentence)
  Sentence = Mark.GreenOnBlack || ' RgRexx plug-in - GRrelink, (c) 2:5085/1, 2000' || Mark.WhiteOnBlack
  rc = SayIn(1, 0, Sentence)

  If Words(ThisArg) \= 3 Then
    Do
      Sentence = Mark.RedOnBlack || 'Unsufficient parameters :' || Mark.WhiteOnBlack
      rc = SayIn(5, 2, Sentence)
      Sentence = Mark.RedOnBlack || 'Regina Hand REXX GRrelink.cmd oldUplink newUplink groupnum' || Mark.WhiteOnBlack
      rc = SayIn(7, 2, Sentence)
      Call SysSleep 5
      Exit -1
    End

  oldUplink = Word(ThisArg, 1)
  Ptr2oldUplink = RgLinkStrToPtr(oldUplink)
  If Ptr2oldUplink = -1 Then
    Do
      Sentence = Mark.RedOnBlack || 'You have not got link number :' oldUplink || Mark.WhiteOnBlack
      rc = SayIn(5, 2, Sentence)
      Call SysSleep 5
      Exit -1
    End

  newUplink = Word(ThisArg, 2)
  Ptr2newUplink = RgLinkStrToPtr(newUplink)
  If Ptr2newUplink = -1 Then
    Do
      Sentence = Mark.RedOnBlack || 'You have not got link number :' newUplink || Mark.WhiteOnBlack
      rc = SayIn(5, 2, Sentence)
      Call SysSleep 5
      Exit -1
    End

  groupnum  = Word(ThisArg, 3)
  counter = 0
  Do i = 1 To RgEchoGetNumber()
    group = RgEchoGetGroup(i) - 1

    If group = groupnum Then
      Do
        counter = counter + 1
        EchoNum.counter = i
        EchoNum.0 = counter
      End

    If i = RgEchoGetNumber() & EchoNum.0 = 0 Then
      Do
        Sentence = Mark.RedOnBlack || 'You have not got group number :' groupnum || Mark.WhiteOnBlack
        rc = SayIn(5, 2, Sentence)
        Call SysSleep 5
        Exit -1
      End
  End

  Sentence = Mark.CyanOnBlack || 'Changing uplink for echo :' || Mark.WhiteOnBlack
  rc = SayIn(5, 2, Sentence)
  Sentence = Mark.CyanOnBlack || '                      To :' NewUplink || Mark.WhiteOnBlack
  rc = SayIn(7, 2, Sentence)

  rc = RgLinkSetCurrent(Ptr2newUplink)
  Do i = 1 To EchoNum.0
    rc = RgEchoSetCurrent(EchoNum.i)
    If RgEchoGetUplink() \= Ptr2newUplink Then
      Do
        Sentence = Mark.CyanOnBlack || RgEchoPtrToStr() || Mark.WhiteOnBlack || Mark.ClearRest
        rc = SayIn(5, 29, Sentence)
        rc = RgEchoSetSubscriber(, , 'UL')
      End
  End

  rc = SayIn(5, 0, Copies(' ', 80))
  rc = SayIn(7, 0, Copies(' ', 80))
  Sentence = Mark.CyanOnBlack || 'Done! Totally changed uplink for' EchoNum.0 'echos.' || Mark.WhiteOnBlack
  rc = SayIn(5, 2, Sentence)
  Call SysSleep 5

Exit 0

/********************************* Functions **********************************/

SayIn: Procedure
  /* Arguments: Ypos, Xpos, Sentence */
  Call SysCurPos Arg(1), Arg(2)
  Say Arg(3)
Return 0

