/*
   Programm     RGLOGCUT.CMD
   Owner        2:5085/1@FIDOnet.org, Sergey Popov
   Date         29.07.2000
   Comment      This script cuts Regina's logfile
   Creator      S. Popov (2:5085/1.41 AKA 2:5085/1.104)
   Note         This script requires Regina-Tosser/2 b091
*/

  /* Initializing */
  If RxFuncQuery( 'SysLoadFuncs' ) \= 0 Then
    Do
      Call RxFuncAdd 'SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs'
      Call SysLoadFuncs
    End /* If RxFuncQuery */

  Parse Upper Arg ThisArg
  Parse Source . . ThisProg
  ThisPath  = FileSpec('D', thisProg) || FileSpec('P', thisProg)

  If Word(ThisArg, 1) \= 'PASS2' Then
    Do
      CurFontSize = SetUserFont(10x6)
      '@Start "Regina''s Log Cutter" /c /min' ThisProg 'PASS2' CurFontSize thisArg
      Exit 1
    End
  PATH.TMP = Value('TMP', , 'OS2ENVIRONMENT') || '\'
  If Path.TMP = '\' Then Path.TMP = 'C:\TMP\'
  Call SysFileTree SubStr(Path.TMP, 1, LastPos('\', Path.TMP) - 1), Found., 'DO'
  If Found.0 = 0 Then
    Call SysMkDir SubStr(Path.TMP, 1, LastPos('\', Path.TMP) - 1)

  MainFlag = Path.TMP || 'RgLogcut.Now'
  Call Stream MainFlag, 'c', 'Open Write'

  CurFontSize = Word(thisArg, 2)
  Call RestoreSystemFont CurFontSize

  Call SysCls
  Call SysCurState 'OFF'

  Mark.WhiteOnBlue  = '1B'x || '[1;37;44m'
  Mark.WhiteOnBlack = '1B'x || '[0m'
  Mark.WhiteOnGreen = '1B'x || '[1;37;42m'
  Mark.WhiteOnRed   = '1B'x || '[1;37;41m'
  Mark.GreenOnBlack = '1B'x || '[1;32;40m'
  Mark.CyanOnBlack  = '1B'x || '[1;36;40m'

  Sentence = Mark.GreenOnBlack || ' RgRexx plug-in - RgLogcut, (c) 2:5085/1, 2000' || Mark.WhiteOnBlack
  rc = SayIn(0, 1, Sentence)
  Sentence = Mark.GreenOnBlack || ' for Regina-Tosser/2 (c) Alexander Kryzhanovsky 2:460/111' || Mark.WhiteOnBlack
  rc = SayIn(1, 1, Sentence)

  IniFile = ThisPath || 'RgLogcut.Ini'
  Sentence = 'Reading default environtment...'
  rc = SayIn(5, 1, Sentence)

  rc = ReadDefEnv(IniFile)

  Sentence = 'Done !'
  rc = SayIn(5, 35, Sentence)

  Sentence = 'Regina''s log will be cutted by' '"'CutBy'"' 'method'
  rc = SayIn(6, 1, Sentence)
  Sentence = 'Prepare log' RgLog || ', wait...'
  rc = SayIn(7, 1, Sentence)

  Temp.log = Path.TMP || 'RgLog.tmp'
  If FileExist(Temp.log) = 'Y' Then
    Call SysFileDelete Temp.log

  If FileExist(RgLog) = 'Y' Then
    Do
      cmd = "'" '@COPY' RgLog Temp.log '2>NUL 1>&2' "'"
      Interpret cmd
    End
  Else
    Do
      Sentence = Mark.RedOnBlack || 'What a hell are You doing?' || Mark.WhiteOnBlack
      rc = SayIn(9, 1, Sentence)
      Sentence = Mark.RedOnBlack || 'You haven''t got Regina''s logfile. Bye !' || Mark.WhiteOnBlack
      rc = SayIn(10, 1, Sentence)
      Call SysSleep 3
      Exit -2
    End
  If Upcase(CutBy) = 'DAYS' Then
    Call CutbyDays
  If Upcase(CutBy) = 'SIZE' Then
    Call CutbySize

  If Upcase(Pack) = 'YES' Then
    Do
      counter = 0
      SubPackage = Package || '.RAR'
      Do While FileExist(SubPackage) = 'Y'
        counter = counter + 1
        SubPackage = Package || '.' || counter || '.RAR'
      End
      If counter \= 0 Then Package = SubPackage

      SemFlag = Path.TMP || 'Archiv.Now'
      '@Start "Archiving logfile" /c /min' Archiver 'm -mm -ep' Package OldLog '2>NUL 1>&2 3>' || SemFlag
      Call SysSleep 2
      Sentence = 'Prepare archive. Wait !'
      rc = SayIn(12, 1, Sentence)
      Do While Stream(SemFlag, 'c', 'Open Write') \= 'READY:'
        Call SysSleep 1
      End
      Call Stream SemFlag, 'c', 'close'
      Call SysFileDelete SemFlag
      Sentence = 'Done !'
      rc = SayIn(12, 18, Sentence)
    End
  Else
    Do
      If Upcase(Package) \= 'NO' Then
        Do
          cmd = "'"'@COPY' OldLog Package '2>NUL 1>&2'"'"
          Interpret cmd
          Call SysFileDelete OldLog
        End
    End

  Call SysFileDelete RgLog
  cmd = "'"'@COPY' NewLog RgLog '2>NUL 1>&2'"'"
  Interpret cmd
  Call SysFileDelete NewLog
  Call SysFileDelete Temp.log

  Call SysCurPos 20, 0
  Say Mark.GreenOnBlack || Center('Ooh, good job. Done!', 80, ' ')
  Say Mark.WhiteOnBlack
  Call SysSleep 3

  Call Stream MainFlag, 'c', 'Close'
  Call SysFileDelete MainFlag
Exit 0

/********************************* Functions **********************************/

SayIn: Procedure
  /* Arguments: Ypos, Xpos, Sentence */
  Call SysCurPos Arg(1), Arg(2)
  Say Arg(3)
Return 0


FileExist: Procedure
  Arg Name
  Rc = SysFileTree(Name, 'FileName', 'FO')
  If FileName.0 = 0 Then
    CompleteCode = 'N'
  Else
    CompleteCode = 'Y'
Return CompleteCode


SetUserFont: Procedure
  Arg thisFont

  '@VER 2>NUL | RXQUEUE 2>NUL 1>&2'
  Do While Queued() \= 0
    curLine = LineIn('QUEUE:')
    If Abbrev(curLine, '樮 ⥬ OS/2') & curLine \= '' Then
      FontMenuEntry = ' ~...'
    If Abbrev(curLine, 'The Operating System/2')  & curLine \= '' Then
      FontMenuEntry = '~Font Size...'
  End

  NewFontSize = ''
  OldFontSize = ''

  if thisFont <> '' then
    do
      parse var thisFont height 'X' width
      NewFontSize = d2c( width ) || d2c( height )
    end
  else
    do
      OldFontSize =  SysIni( 'USER', 'Shield', FontMenuEntry )
      if OldFontSize = 'ERROR:' then
        OldFontSize = ''
      Return OldFontSize
    end /* if thisFont <> '' then */

       /* save the old font size                                    */
  OldFontSize =  SysIni( 'USER', 'Shield', FontMenuEntry )
    if OldFontSize = 'ERROR:' | OldFontSize = '' then
      OldFontSize = ''

       /* set the new font size                                     */
  call SysIni 'USER', 'Shield', FontMenuEntry, newFontSize

Return OldFontSize


RestoreSystemFont: Procedure
  Arg OldFontSize

  '@VER 2>NUL | RXQUEUE 2>NUL 1>&2'
  Do While Queued() \= 0
    curLine = LineIn('QUEUE:')
    If Abbrev(curLine, '樮 ⥬ OS/2') & curLine \= '' Then
      FontMenuEntry = ' ~...'
    If Abbrev(curLine, 'The Operating System/2')  & curLine \= '' Then
      FontMenuEntry = '~Font Size...'
  End

  If OldFontSize <> '' then
    call SysIni 'USER', 'Shield', FontMenuEntry, OldFontSize
  else
    call SysIni 'USER', 'Shield', FontMenuEntry, 'DELETE:'
Return 0


WriteLineToFile: Procedure
  /* Arguments: FileName, Sentence */
  Do While Stream(Arg(1), 'c', 'Open Write') \= 'READY:'
    Call SysSleep 1
  End
  Call Stream  Arg(1),'c', 'Close'

  Call Stream  Arg(1),'c', 'Seek <0'
  Call LineOut Arg(1), Arg(2)
  Call Stream  Arg(1),'c', 'Close'
Return


ReadDefEnv:
  Arg IniFile

  DefVar.0 = 0
  Do While Lines(IniFile) \= 0
    ReadLine     = LineIn(IniFile)
    If Left(ReadLine,1) \= ';' | Left(ReadLine,1) \= '' Then
      Do
        DefVar.0     = DefVar.0 + 1
        Index        = DefVar.0
        DefVar.Index = ReadLine
      End
  End
  Call Stream IniFile, 'c', 'CLOSE'

  Do i = 1 To DefVar.0
    VarName = Word(Defvar.i, 1)
    Select
      When Upcase(VarName) = 'MAINPATH' Then
        Do
          MainPath = Word(Defvar.i, 2)
          If Left(MainPath, 1) \= '\' Then
            MainPath = MainPath || '\'
        End
      When Upcase(VarName) = 'RGLOG' Then
        RgLog = Word(Defvar.i, 2)
      When Upcase(VarName) = 'CUTBY' Then
        Do
          CutBy = Word(Defvar.i, 2)
          If Upcase(CutBy) = 'DAYS' Then
            CutDays = Word(Defvar.i, 3)
          If Upcase(CutBy) = 'SIZE' Then
            CutSize = Word(Defvar.i, 3)
        End
      When Upcase(VarName) = 'PACK' Then
        Pack = Word(Defvar.i, 2)
      When Upcase(VarName) = 'ARCHIVER' Then
        Archiver = Word(Defvar.i, 2)
      When Upcase(VarName) = 'PACKAGE' Then
        Do
          VarValue = Word(Defvar.i, 2)
          If Upcase(VarValue) \= 'NO' Then
            Do
              Parse Value VarValue with OutName '%' elements '.' extention
              Parse Value elements with element.1 '%' element.2 '%' element.3
              Do k = 1 To 3
                If Upcase(element.k) = 'D' Then
                  element.k = Left(Date('E'), 2)
                If Upcase(element.k) = 'M' Then
                  element.k = SubStr(Date('E'), 4, 2)
                If Upcase(element.k) = 'Y' Then
                  element.k = Right(Date('E'), 2)
              End
              Package = OutName || element.1 || element.2 || element.3  || '.' || extention
              If Length(Package) = LastPos('.', Package) Then
                Package = Left(Package, LastPos('.', Package)-1)
            End
          Else
            Package = 'NO'
        End
      Otherwise
    End
  End
Return 0


Upcase: Procedure
  Arg String
Return Translate(String, ABCDEFGHIJKLMNOPQRSTUVWXYZ,,
                         abcdefghijklmnopqrstuvwxyz)

Lowcase: Procedure
  Arg String
Return Translate(String, abcdefghijklmnopqrstuvwxyz,,
                         ABCDEFGHIJKLMNOPQRSTUVWXYZ)


CutbyDays:

  CurDate = Date('S')
  CurDate = Right(CurDate, 2) || '/' || SubStr(CurDate, 5, 2) || '/' || Left(CurDate, 4)

  CurDir = Directory()
  Call Directory(SubStr(MainPath, 1, LastPos('\', MainPath)-1))
  Line.1  = '/* Regina''s Rexx script */'
  Line.2  = 'CurDay = RgDateToDay(''' || CurDate || ''')'
  Line.3  = 'Call LineOut ''' || Path.TMP || 'CurDay'', CurDay'
  Line.4  = 'Call Stream ''' || Path.TMP || 'CurDay'', ''c'', ''Close'''
  Line.5  = 'Exit 0'
  Line.0  = 5

  If FileExist(Path.TMP || 'CurDay') = 'Y' Then
    Call SysFileDelete Path.TMP || 'CurDay'

  CmdName = Path.TMP || 'CurDay.Cmd'
  If FileExist(CmdName) = 'Y' Then
    Call SysFileDelete CmdName

  Do i = 1 To Line.0
    Call WriteLineToFile CmdName, Line.i
  End

  SemFlag = Path.TMP || 'CurDay.Now'
  '@Start "Regina-Day" /c /min' MainPath || 'Regina.exe Hand REXX' CmdName '1>NUL 2>NUL 3>' || SemFlag

  Call SysSleep 2
  Do While Stream(SemFlag, 'c', 'Open Write') \= 'READY:'
    Call SysSleep 1
  End
  Call Stream SemFlag, 'c', 'close'
  Call SysFileDelete SemFlag
  Call SysFileDelete CmdName

  CurDay = LineIn(Path.TMP || 'CurDay')
  Call Stream Path.TMP || 'CurDay', 'c', 'close'
  Call SysFileDelete Path.TMP || 'CurDay'

  BegDay = CurDay - CutDays

  Line.1  = '/* Regina''s Rexx script */'
  Line.2  = 'BegDate = RgDayToDate(' || BegDay || ')'
  Line.3  = 'Call LineOut ''' || Path.TMP || 'BegDate'', BegDate'
  Line.4  = 'Call Stream ''' || Path.TMP || 'BegDate'', ''c'', ''Close'''
  Line.5  = 'Exit 0'
  Line.0  = 5

  If FileExist(Path.TMP || 'BegDate') = 'Y' Then
    Call SysFileDelete Path.TMP || 'BegDate'

  CmdName = Path.TMP || 'BegDate.Cmd'
  If FileExist(CmdName) = 'Y' Then
    Call SysFileDelete CmdName

  Do i = 1 To Line.0
    Call WriteLineToFile CmdName, Line.i
  End

  SemFlag = Path.TMP || 'BegDate.Now'
  '@Start "Regina-Date" /c /min' MainPath || 'Regina.exe Hand REXX' CmdName '2>NUL 1>&2 3>' || SemFlag

  Call SysSleep 2
  Do While Stream(SemFlag, 'c', 'Open Write') \= 'READY:'
    Call SysSleep 1
  End
  Call Stream SemFlag, 'c', 'close'
  Call SysFileDelete SemFlag
  Call SysFileDelete CmdName

  BegDate = LineIn(Path.TMP || 'BegDate')
  Call Stream Path.TMP || 'BegDate', 'c', 'close'
  Call SysFileDelete Path.TMP || 'BegDate'

  If DataType(BegDate) \= 'CHAR' Then
    Do
      Sentence = Mark.RedOnBlack || 'Sorry! Can''t determine Date Begin value' || Mark.WhiteOnBlack
      rc = SayIn(9, 1, Sentence)
      Call SysSleep 3
      Call Directory(CurDir)
      Exit -2
    End

  NewLog = Path.TMP || 'RgLog.New'
  If FileExist(NewLog) = 'Y' Then
    Call SysFileDelete NewLog
  If Upcase(Package) \= 'NO' Then
    Do
      OldLog = Path.TMP || FileSpec('N', Package)
      If FileExist(OldLog) = 'Y' Then
        Call SysFileDelete OldLog
    End

  counter = 0
  Do While Lines(Temp.log) \= 0
    counter = counter + 1
    Line.counter = LineIn(Temp.log)
    Line.0 = counter
  End
  Call Stream Temp.log, 'c', 'Close'

  Sentence = 'Totally copied to archive -'
  rc = SayIn(9, 1, Sentence)
  Sentence = 'Totally copied to new log -'
  rc = SayIn(10, 1, Sentence)
  counter = 0
  Do i = 1 To Line.0
    If Word(Line.i, 1) = BegDate Then
      Do
        counter = 0
        Do k = i To Line.0
          counter = counter + 1
          rc = SayIn(10, 30, Mark.CyanOnBlack || counter || Mark.WhiteOnBlack)
          Call WriteLineToFile NewLog, Line.k
        End
        Leave i
      End
    Else
      Do
        If Upcase(Package) \= 'NO' Then
          Do
            counter = counter + 1
            rc = SayIn(9, 30, Mark.CyanOnBlack || counter || Mark.WhiteOnBlack)
            Call WriteLineToFile OldLog, Line.i
          End
      End
  End
  Drop Line.

  Call Directory(CurDir)
Return


CutbySize:

  NewLog = Path.TMP || 'RgLog.New'
  If FileExist(NewLog) = 'Y' Then
    Call SysFileDelete NewLog
  If Upcase(Package) \= 'NO' Then
    Do
      OldLog = Path.TMP || FileSpec('N', Package)
      If FileExist(OldLog) = 'Y' Then
        Call SysFileDelete OldLog
    End

  counter = 0
  Do While Lines(Temp.log) \= 0
    counter = counter + 1
    Line.counter = LineIn(Temp.log)
    Line.0 = counter
  End
  Call Stream Temp.log, 'c', 'Close'

  Call SysFileTree Temp.log, Found., 'F'

  LogFileSize = Word(Found.1, 3)

  NewLines  = Format((Line.0 * CutSize) / LogFileSize, , 0)
  StartLine = Line.0 - NewLines

  Sentence = 'Totally copied to archive -'
  rc = SayIn(9, 1, Sentence)
  Sentence = 'Totally copied to new log -'
  rc = SayIn(10, 1, Sentence)

  counter = 0
  If Upcase(Package) \= 'NO' Then
    Do i = 1 To StartLine
      counter = counter + 1
      rc = SayIn(9, 30, Mark.CyanOnBlack || counter || Mark.WhiteOnBlack)
      Call WriteLineToFile OldLog, Line.i
    End

  counter = 0
  Do i = (StartLine + 1) To Line.0
    counter = counter + 1
    rc = SayIn(10, 30, Mark.CyanOnBlack || counter || Mark.WhiteOnBlack)
    Call WriteLineToFile NewLog, Line.i
  End

Return
